SystemOrganization addCategory: #Esse!

Morph subclass: #DroppedMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

!DroppedMorph methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	color := Color blue.
	self position: 250 @ 100! !

!DroppedMorph methodsFor: 'as yet unclassified' stamp: ''!
rejectDropMorphEvent: t1 
	| t2 |
	t2 := t1 hand.
	WorldState
		addDeferredUIMessage: [t2 grabMorph: self].
	t1 wasHandled: true! !

!DroppedMorph methodsFor: 'as yet unclassified' stamp: ''!
viewBox
	^ self pasteUpMorph viewBox! !

Morph subclass: #MyMorphs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

!MyMorphs methodsFor: 'as yet unclassified' stamp: ''!
handleKeystroke: t1 
	| t2 |
	t2 := t1 keyValue.
	t2 = $= asciiValue
		ifTrue: [self startStepping].
	t2 = $- asciiValue
		ifTrue: [self stopStepping]! !

!MyMorphs methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	color := Color red.
	bounds := 0 @ 0 extent: 300 @ 100.
	self position: self position - (300 @ 0) + (0 @ 250)! !

!MyMorphs methodsFor: 'as yet unclassified' stamp: ''!
step
	self position: self position + (1 @ 0)! !

!MyMorphs methodsFor: 'as yet unclassified' stamp: ''!
stepTime
	^ 30! !

Morph subclass: #ReceiverMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

!ReceiverMorph methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	color := Color red.
	bounds := 0 @ 0 extent: 100 @ 100! !

!ReceiverMorph methodsFor: 'as yet unclassified' stamp: ''!
repelsMorph: t1 event: t2 
	^ (self wantsDroppedMorph: t1 event: t2) not! !

!ReceiverMorph methodsFor: 'as yet unclassified' stamp: ''!
wantsDroppedMorph: t1 event: t2 
	^ t1 color = Color blue! !

Morph subclass: #Rect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

!Rect methodsFor: 'as yet unclassified' stamp: ''!
handleKeystroke: t1 
	| t2 |
	t2 := t1 keyValue.
	t2 = 30
		ifTrue: [self position: self position - (0 @ 1 * Stage Speed).
			Stage DontMoov: 0 @ -1 * Stage Speed].
	t2 = 28
		ifTrue: [self position: self position - (Stage Speed * 1 @ 0).
			Stage DontMoov: Stage Speed * -1 @ 0].
	t2 = 31
		ifTrue: [self position: self position + (0 @ 1 * Stage Speed).
			Stage DontMoov: 0 @ 1 * Stage Speed].
	t2 = 29
		ifTrue: [self position: self position + (Stage Speed * 1 @ 0).
			Stage DontMoov: Stage Speed * 1 @ 0]! !

!Rect methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	color := Color red.
	bounds := 50 @ 50 extent: 150 @ 150! !

!Rect methodsFor: 'as yet unclassified' stamp: ''!
step
	self changed! !

!Rect methodsFor: 'as yet unclassified' stamp: ''!
stepTime
	^ 0! !

Morph subclass: #Stage
	instanceVariableNames: 'speed'
	classVariableNames: 'stage'
	poolDictionaries: ''
	category: 'Esse'!

!Stage class methodsFor: 'as yet unclassified' stamp: ''!
Create
	^ stage := Stage new yourself! !

!Stage class methodsFor: 'as yet unclassified' stamp: ''!
DontMoov: t1 
	^ stage Position: t1 yourself! !

!Stage class methodsFor: 'as yet unclassified' stamp: ''!
Speed
	^ stage speed! !

!Stage methodsFor: 'as yet unclassified' stamp: ''!
Position: t1 
	self position: self position + t1! !

!Stage methodsFor: 'as yet unclassified' stamp: ''!
handleKeystroke: t1 
	| t2 |
	t2 := t1 keyValue.
	t2 = 30
		ifTrue: [self position: self position + (0 @ 1 * self speed)].
	t2 = 28
		ifTrue: [self position: self position + (self speed * 1 @ 0)].
	t2 = 31
		ifTrue: [self position: self position - (0 @ 1 * self speed)].
	t2 = 29
		ifTrue: [self position: self position - (self speed * 1 @ 0)].
	t2 = $, asciiValue
		ifTrue: [self speed > 1
				ifTrue: [speed := self speed - 1]].
	t2 = $. asciiValue
		ifTrue: [speed := self speed + 1]! !

!Stage methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	color := Color green.
	speed := 2.
	bounds := 0 @ 0 extent: 1000 @ 1000! !

!Stage methodsFor: 'as yet unclassified' stamp: ''!
speed
	^ speed! !

!Stage methodsFor: 'as yet unclassified' stamp: ''!
speed: t1 
	speed := t1! !

!Stage methodsFor: 'as yet unclassified' stamp: ''!
step
	self changed! !

!Stage methodsFor: 'as yet unclassified' stamp: ''!
stepTime
	^ 0! !

BorderedMorph subclass: #Arrow
	uses: TAbleToRotate
	instanceVariableNames: 'startarrow drow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

Arrow class
	uses: TAbleToRotate classTrait
	instanceVariableNames: ''!

!Arrow methodsFor: 'as yet unclassified' stamp: ''!
ArrowEndSize: t1 position: t2 
	| t3 |
	t3 := ArrowEnd new color: self color.
	t3 Size: t1.
	t3 position: self position + t2.
	t3 openInWorld.
	startarrow addMorph: t3! !

!Arrow methodsFor: 'as yet unclassified' stamp: ''!
Start
	startarrow := ArrowEnd new color: self color.
	startarrow Size: 0 @ 0.
	startarrow position: self position.
	startarrow openInWorld.
	self addMorph: startarrow! !

!Arrow methodsFor: 'accessing' stamp: ''!
borderWidth: t1 
	| t2 |
	t2 := self center.
	super borderWidth: t1.
	super extent: self defaultExtent.
	self center: t2! !

!Arrow methodsFor: 'defaults' stamp: ''!
defaultBorderWidth
	^ 1! !

!Arrow methodsFor: 'defaults' stamp: ''!
defaultColor
	^ Color black! !

!Arrow methodsFor: 'accessing' stamp: ''!
drow
	^ drow! !

!Arrow methodsFor: 't-rotating' stamp: ''!
forwardDirection
	^ self
		valueOfProperty: #forwardDirection
		ifAbsent: [0.0]! !

!Arrow methodsFor: 't-rotating' stamp: ''!
forwardDirection: t1 
	self setProperty: #forwardDirection toValue: t1! !

!Arrow methodsFor: 'events-processing' stamp: ''!
handleKeystroke: t1 
	| t2 |
	t2 := t1 keyValue.
	t2 = 30
		ifTrue: [self position: self position - (0 @ 1 * Stage Speed).
			startarrow position: startarrow position + (0 @ 1 * Stage Speed).
			drow
				ifTrue: [self ArrowEndSize: 30 @ 30 position: 10 @ 10 + (0 @ 1 * Stage Speed)].
			Stage DontMoov: 0 @ -1 * Stage Speed].
	t2 = 28
		ifTrue: [self position: self position - (Stage Speed * 1 @ 0).
			startarrow position: startarrow position + (Stage Speed * 1 @ 0).
			drow
				ifTrue: [self ArrowEndSize: 30 @ 30 position: 10 @ 10 + (Stage Speed * 1 @ 0)].
			Stage DontMoov: Stage Speed * -1 @ 0].
	t2 = 31
		ifTrue: [self position: self position + (0 @ 1 * Stage Speed).
			startarrow position: startarrow position - (0 @ 1 * Stage Speed).
			drow
				ifTrue: [self ArrowEndSize: 30 @ 30 position: 10 @ 10 - (0 @ 1 * Stage Speed)].
			Stage DontMoov: 0 @ 1 * Stage Speed].
	t2 = 29
		ifTrue: [self position: self position + (Stage Speed * 1 @ 0).
			startarrow position: startarrow position - (Stage Speed * 1 @ 0).
			drow
				ifTrue: [self ArrowEndSize: 30 @ 30 position: 10 @ 10 - (Stage Speed * 1 @ 0)].
			Stage DontMoov: Stage Speed * 1 @ 0].
	t2 = $a asciiValue
		ifTrue: [drow
				ifTrue: [drow := false]
				ifFalse: [drow := true]]! !

!Arrow methodsFor: 't-rotating' stamp: ''!
heading
	^ self owner
		ifNil: [self forwardDirection]
		ifNotNil: [self forwardDirection + self owner degreesOfFlex]! !

!Arrow methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	color := Color red.
	self Start.
	drow := false.
	bounds := 0 @ 0 extent: 50 @ 50! !

!Arrow methodsFor: 't-rotating' stamp: ''!
prepareForRotating
	^ self addFlexShell! !

!Arrow methodsFor: 't-rotating' stamp: ''!
rotationDegrees
	^ 0.0! !

!Arrow methodsFor: 't-rotating' stamp: ''!
rotationDegrees: t1 
	^ self! !

!Arrow methodsFor: 't-rotating' stamp: ''!
setDirectionFrom: t1 
	| t2 t3 |
	t2 := (self transformFromWorld globalPointToLocal: t1)
				- self referencePosition.
	t3 := t2 degrees + 90.0.
	self forwardDirection: (t3 \\ 360) rounded! !

!Arrow methodsFor: 'stepping and presenter' stamp: ''!
step
	self changed! !

!Arrow methodsFor: 'testing' stamp: ''!
stepTime
	^ 0! !

BorderedMorph subclass: #ArrowEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

!ArrowEnd methodsFor: 'as yet unclassified' stamp: ''!
Size: t1 
	bounds := 0 @ 0 extent: t1! !

!ArrowEnd methodsFor: 'as yet unclassified' stamp: ''!
borderWidth: t1 
	| t2 |
	t2 := self center.
	super borderWidth: t1.
	super extent: self defaultExtent.
	self center: t2! !

!ArrowEnd methodsFor: 'as yet unclassified' stamp: ''!
defaultBorderWidth
	^ 1! !

!ArrowEnd methodsFor: 'as yet unclassified' stamp: ''!
defaultColor
	^ Color black! !

!ArrowEnd methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	color := Color red.
	bounds := 0 @ 0 extent: 50 @ 50! !

BorderedMorph subclass: #Camera
	instanceVariableNames: 'magnification trackPointer srcExtent showPointer look speed'
	classVariableNames: 'RecursionLock'
	poolDictionaries: ''
	category: 'Esse'!

!Camera methodsFor: 'as yet unclassified' stamp: ''!
borderWidth: t1 
	| t2 |
	t2 := self center.
	super borderWidth: t1.
	super extent: self defaultExtent.
	self center: t2! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
defaultBorderWidth
	^ 1! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
defaultColor
	^ Color black! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
defaultExtent
	^ (srcExtent * magnification) truncated + (2 * borderWidth)! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
drawOn: t1 
	super drawOn: t1.
	t1 isShadowDrawing
		ifFalse: [t1 paintImage: self magnifiedForm at: self innerBounds origin]! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
extent: t1 
	srcExtent := t1 - (2 * borderWidth) // magnification.
	^ super extent: self defaultExtent! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
handleKeystroke: t1 
	| t2 |
	t2 := t1 keyValue.
	t2 = 30
		ifTrue: [look := self look - (0 @ 1 * self speed)].
	t2 = 28
		ifTrue: [look := self look - (self speed * 1 @ 0)].
	t2 = 31
		ifTrue: [look := self look + (0 @ 1 * self speed)].
	t2 = 29
		ifTrue: [look := self look + (self speed * 1 @ 0)].
	t2 = $, asciiValue
		ifTrue: [self speed > 1
				ifTrue: [speed := self speed - 1]].
	t2 = $. asciiValue
		ifTrue: [speed := self speed + 1].
	t2 = $- asciiValue
		ifTrue: [self magnification > 1
				ifTrue: [magnification := self magnification - 0.01]].
	t2 = $= asciiValue
		ifTrue: [magnification := self magnification + 0.01]! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	trackPointer := true.
	showPointer := false.
	magnification := 1.
	look := 100 @ 100.
	speed := 2.
	self extent: 128 @ 128! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
look
	^ look! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
look: t1 
	look := t1! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
magnification
	^ magnification! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
magnification: t1 
	magnification := t1! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
magnifiedForm
	| t1 t2 t3 |
	t1 := self sourceRectFrom: self sourcePoint.
	(RecursionLock isNil
			and: [self showPointer
					or: [t1 intersects: self bounds]])
		ifTrue: [RecursionLock := self.
			t2 := self currentWorld
						patchAt: t1
						without: self
						andNothingAbove: false.
			RecursionLock := nil]
		ifFalse: [t2 := Display copy: t1].
	t3 := t2
				magnify: t2 boundingBox
				by: magnification
				smoothing: (magnification isInteger
						ifTrue: [1]
						ifFalse: [2]).
	self showPointer
		ifTrue: [t3
				reverse: (t3 center - (2 @ 2) extent: 4 @ 4)
				fillColor: Color white].
	^ t3! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
showPointer
	^ showPointer
		ifNil: [showPointer := false]! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
sourcePoint
	^ look! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
sourceRect
	^ self sourceRectFrom: self sourcePoint! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
sourceRectFrom: t1 
	^ (t1 extent: srcExtent)
		translateBy: srcExtent // -2 + 1! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
speed
	^ speed! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
speed: t1 
	speed := t1! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
step
	self changed! !

!Camera methodsFor: 'as yet unclassified' stamp: ''!
stepTime
	^ 0! !
